# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from fireblocks.models.asset_class import AssetClass
from fireblocks.models.asset_details_metadata import AssetDetailsMetadata
from fireblocks.models.asset_details_onchain import AssetDetailsOnchain
from typing import Optional, Set
from typing_extensions import Self

class Asset(BaseModel):
    """
    Asset
    """ # noqa: E501
    id: StrictStr = Field(description="The ID of the asset")
    legacy_id: StrictStr = Field(description="The Legacy ID of the asset", alias="legacyId")
    blockchain_id: Optional[StrictStr] = Field(default=None, description="The ID of the asset's blockchain", alias="blockchainId")
    display_name: StrictStr = Field(description="Asset's display name", alias="displayName")
    display_symbol: StrictStr = Field(description="Asset's display symbol", alias="displaySymbol")
    asset_class: AssetClass = Field(alias="assetClass")
    onchain: Optional[AssetDetailsOnchain] = None
    metadata: AssetDetailsMetadata
    __properties: ClassVar[List[str]] = ["id", "legacyId", "blockchainId", "displayName", "displaySymbol", "assetClass", "onchain", "metadata"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Asset from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of onchain
        if self.onchain:
            _dict['onchain'] = self.onchain.to_dict()
        # override the default output from pydantic by calling `to_dict()` of metadata
        if self.metadata:
            _dict['metadata'] = self.metadata.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Asset from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "legacyId": obj.get("legacyId"),
            "blockchainId": obj.get("blockchainId"),
            "displayName": obj.get("displayName"),
            "displaySymbol": obj.get("displaySymbol"),
            "assetClass": obj.get("assetClass"),
            "onchain": AssetDetailsOnchain.from_dict(obj["onchain"]) if obj.get("onchain") is not None else None,
            "metadata": AssetDetailsMetadata.from_dict(obj["metadata"]) if obj.get("metadata") is not None else None
        })
        return _obj


