# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from fireblocks.models.collection_type import CollectionType
from typing import Optional, Set
from typing_extensions import Self

class CollectionDeployRequestDto(BaseModel):
    """
    CollectionDeployRequestDto
    """ # noqa: E501
    base_asset_id: StrictStr = Field(description="The blockchain base assetId", alias="baseAssetId")
    vault_account_id: StrictStr = Field(description="The id of the vault account that initiated the request to issue the token", alias="vaultAccountId")
    type: CollectionType
    name: StrictStr = Field(description="A string that represents the name of the collection")
    symbol: StrictStr = Field(description="A string that represents the symbol of the collection")
    admin_address: StrictStr = Field(description="The EVM address of the user that will be set as the admin user of the collection", alias="adminAddress")
    display_name: Optional[StrictStr] = Field(default=None, description="A string to display as a name of the collection", alias="displayName")
    __properties: ClassVar[List[str]] = ["baseAssetId", "vaultAccountId", "type", "name", "symbol", "adminAddress", "displayName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CollectionDeployRequestDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CollectionDeployRequestDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "baseAssetId": obj.get("baseAssetId"),
            "vaultAccountId": obj.get("vaultAccountId"),
            "type": obj.get("type"),
            "name": obj.get("name"),
            "symbol": obj.get("symbol"),
            "adminAddress": obj.get("adminAddress"),
            "displayName": obj.get("displayName")
        })
        return _obj


