# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from fireblocks.models.collection_metadata_dto import CollectionMetadataDto
from fireblocks.models.collection_type import CollectionType
from typing import Optional, Set
from typing_extensions import Self

class CollectionLinkDto(BaseModel):
    """
    CollectionLinkDto
    """ # noqa: E501
    id: StrictStr = Field(description="The collection id")
    status: StrictStr = Field(description="The collection status")
    type: CollectionType
    display_name: Optional[StrictStr] = Field(default=None, description="The display name of the collection. If was not provided, would be taken from the contract template", alias="displayName")
    collection_metadata: Optional[CollectionMetadataDto] = Field(default=None, description="The collection's metadata", alias="collectionMetadata")
    __properties: ClassVar[List[str]] = ["id", "status", "type", "displayName", "collectionMetadata"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['PENDING', 'COMPLETED']):
            raise ValueError("must be one of enum values ('PENDING', 'COMPLETED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CollectionLinkDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of collection_metadata
        if self.collection_metadata:
            _dict['collectionMetadata'] = self.collection_metadata.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CollectionLinkDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "status": obj.get("status"),
            "type": obj.get("type"),
            "displayName": obj.get("displayName"),
            "collectionMetadata": CollectionMetadataDto.from_dict(obj["collectionMetadata"]) if obj.get("collectionMetadata") is not None else None
        })
        return _obj


