# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from fireblocks.models.abi_function import AbiFunction
from typing import Optional, Set
from typing_extensions import Self

class ContractWithAbiDto(BaseModel):
    """
    ContractWithAbiDto
    """ # noqa: E501
    contract_address: StrictStr = Field(description="The address of the contract", alias="contractAddress")
    base_asset_id: StrictStr = Field(description="The blockchain base assetId", alias="baseAssetId")
    name: StrictStr = Field(description="The name of the contract")
    abi: List[AbiFunction] = Field(description="The ABI of the contract")
    is_proxy: Optional[StrictBool] = Field(default=None, description="Whether the contract is a proxy contract", alias="isProxy")
    implementation: Optional[StrictStr] = Field(default=None, description="The implementation contract address")
    is_public: StrictBool = Field(description="Whether the contract ABI is public", alias="isPublic")
    __properties: ClassVar[List[str]] = ["contractAddress", "baseAssetId", "name", "abi", "isProxy", "implementation", "isPublic"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ContractWithAbiDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in abi (list)
        _items = []
        if self.abi:
            for _item_abi in self.abi:
                if _item_abi:
                    _items.append(_item_abi.to_dict())
            _dict['abi'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ContractWithAbiDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contractAddress": obj.get("contractAddress"),
            "baseAssetId": obj.get("baseAssetId"),
            "name": obj.get("name"),
            "abi": [AbiFunction.from_dict(_item) for _item in obj["abi"]] if obj.get("abi") is not None else None,
            "isProxy": obj.get("isProxy"),
            "implementation": obj.get("implementation"),
            "isPublic": obj.get("isPublic")
        })
        return _obj


