# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List
from fireblocks.models.smart_transfer_statistic_inflow import SmartTransferStatisticInflow
from fireblocks.models.smart_transfer_statistic_outflow import SmartTransferStatisticOutflow
from typing import Optional, Set
from typing_extensions import Self

class SmartTransferStatistic(BaseModel):
    """
    Smart transfers statistic
    """ # noqa: E501
    inflow: SmartTransferStatisticInflow
    outflow: SmartTransferStatisticOutflow
    total_active_tickets: StrictInt = Field(description="Number of total active tickets", alias="totalActiveTickets")
    total_inactive_tickets: StrictInt = Field(description="Number of total inactive tickets (expired, canceled, completed)", alias="totalInactiveTickets")
    __properties: ClassVar[List[str]] = ["inflow", "outflow", "totalActiveTickets", "totalInactiveTickets"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SmartTransferStatistic from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of inflow
        if self.inflow:
            _dict['inflow'] = self.inflow.to_dict()
        # override the default output from pydantic by calling `to_dict()` of outflow
        if self.outflow:
            _dict['outflow'] = self.outflow.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SmartTransferStatistic from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "inflow": SmartTransferStatisticInflow.from_dict(obj["inflow"]) if obj.get("inflow") is not None else None,
            "outflow": SmartTransferStatisticOutflow.from_dict(obj["outflow"]) if obj.get("outflow") is not None else None,
            "totalActiveTickets": obj.get("totalActiveTickets"),
            "totalInactiveTickets": obj.get("totalInactiveTickets")
        })
        return _obj


