# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from fireblocks.models.travel_rule_geographic_address import TravelRuleGeographicAddress
from fireblocks.models.travel_rule_legal_person_name_identifier import TravelRuleLegalPersonNameIdentifier
from fireblocks.models.travel_rule_national_identification import TravelRuleNationalIdentification
from typing import Optional, Set
from typing_extensions import Self

class TravelRuleLegalPerson(BaseModel):
    """
    TravelRuleLegalPerson
    """ # noqa: E501
    name: Optional[TravelRuleLegalPersonNameIdentifier] = None
    geographic_address: Optional[List[TravelRuleGeographicAddress]] = Field(default=None, description="The array of geographic addresses associated with the legal person.", alias="geographicAddress")
    national_identification: Optional[TravelRuleNationalIdentification] = Field(default=None, alias="nationalIdentification")
    customer_identification: Optional[StrictStr] = Field(default=None, description="A unique identifier that identifies the customer in the organization's context. The value must be encrypted.", alias="customerIdentification")
    customer_number: Optional[StrictStr] = Field(default=None, description="A distinct identifier that uniquely identifies the customer within the organization. The value must be encrypted.", alias="customerNumber")
    country_of_registration: Optional[StrictStr] = Field(default=None, description="The ISO-3166 Alpha-2 country code where the legal person is registered. The value must be encrypted.", alias="countryOfRegistration")
    __properties: ClassVar[List[str]] = ["name", "geographicAddress", "nationalIdentification", "customerIdentification", "customerNumber", "countryOfRegistration"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TravelRuleLegalPerson from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of name
        if self.name:
            _dict['name'] = self.name.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in geographic_address (list)
        _items = []
        if self.geographic_address:
            for _item_geographic_address in self.geographic_address:
                if _item_geographic_address:
                    _items.append(_item_geographic_address.to_dict())
            _dict['geographicAddress'] = _items
        # override the default output from pydantic by calling `to_dict()` of national_identification
        if self.national_identification:
            _dict['nationalIdentification'] = self.national_identification.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TravelRuleLegalPerson from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": TravelRuleLegalPersonNameIdentifier.from_dict(obj["name"]) if obj.get("name") is not None else None,
            "geographicAddress": [TravelRuleGeographicAddress.from_dict(_item) for _item in obj["geographicAddress"]] if obj.get("geographicAddress") is not None else None,
            "nationalIdentification": TravelRuleNationalIdentification.from_dict(obj["nationalIdentification"]) if obj.get("nationalIdentification") is not None else None,
            "customerIdentification": obj.get("customerIdentification"),
            "customerNumber": obj.get("customerNumber"),
            "countryOfRegistration": obj.get("countryOfRegistration")
        })
        return _obj


