# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class TravelRuleValidateGeographicAddress(BaseModel):
    """
    TravelRuleValidateGeographicAddress
    """ # noqa: E501
    street_name: Optional[StrictStr] = Field(default=None, description="Name of a street or thoroughfare", alias="streetName")
    town_name: Optional[StrictStr] = Field(default=None, description="Name of a built-up area, with defined boundaries, and a local government", alias="townName")
    country: Optional[StrictStr] = Field(default=None, description="Nation with its own government (ISO-3166 Alpha-2 country code)")
    building_number: Optional[StrictStr] = Field(default=None, description="Number that identifies the position of a building on a street", alias="buildingNumber")
    post_code: Optional[StrictStr] = Field(default=None, description="Identifier consisting of a group of letters and/or numbers added to a postal address to assist the sorting of mail", alias="postCode")
    address_type: Optional[StrictStr] = Field(default=None, description="Specifies the type of address. Acceptable values are: - 'HOME': Residential, the home address - 'BIZZ': Business, the business address - 'GEOG': Geographic, an unspecified physical (geographical) address", alias="addressType")
    department: Optional[StrictStr] = Field(default=None, description="Identification of a division of a large organisation or building")
    sub_department: Optional[StrictStr] = Field(default=None, description="Identification of a sub-division of a large organisation or building", alias="subDepartment")
    building_name: Optional[StrictStr] = Field(default=None, description="Name of the building or house", alias="buildingName")
    floor: Optional[StrictStr] = Field(default=None, description="Floor or storey within a building")
    post_box: Optional[StrictStr] = Field(default=None, description="Numbered box in a post office", alias="postBox")
    room: Optional[StrictStr] = Field(default=None, description="Building room number")
    town_location_name: Optional[StrictStr] = Field(default=None, description="Specific location name within the town", alias="townLocationName")
    district_name: Optional[StrictStr] = Field(default=None, description="Identifies a subdivision within a country subdivision", alias="districtName")
    country_sub_division: Optional[StrictStr] = Field(default=None, description="Identifies a subdivision of a country such as state, region, or province", alias="countrySubDivision")
    address_line: Optional[List[StrictStr]] = Field(default=None, description="Information that locates and identifies a specific address, presented in free format text", alias="addressLine")
    __properties: ClassVar[List[str]] = ["streetName", "townName", "country", "buildingNumber", "postCode", "addressType", "department", "subDepartment", "buildingName", "floor", "postBox", "room", "townLocationName", "districtName", "countrySubDivision", "addressLine"]

    @field_validator('address_type')
    def address_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['HOME', 'BIZZ', 'GEOG']):
            raise ValueError("must be one of enum values ('HOME', 'BIZZ', 'GEOG')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TravelRuleValidateGeographicAddress from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TravelRuleValidateGeographicAddress from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "streetName": obj.get("streetName"),
            "townName": obj.get("townName"),
            "country": obj.get("country"),
            "buildingNumber": obj.get("buildingNumber"),
            "postCode": obj.get("postCode"),
            "addressType": obj.get("addressType"),
            "department": obj.get("department"),
            "subDepartment": obj.get("subDepartment"),
            "buildingName": obj.get("buildingName"),
            "floor": obj.get("floor"),
            "postBox": obj.get("postBox"),
            "room": obj.get("room"),
            "townLocationName": obj.get("townLocationName"),
            "districtName": obj.get("districtName"),
            "countrySubDivision": obj.get("countrySubDivision"),
            "addressLine": obj.get("addressLine")
        })
        return _obj


